module Perlin
  NUM_VALUES = 100
  VALUES = Array.new(NUM_VALUES){2.0*rand - 1.0}
  
  def self.lerp(t, a, b)
    a + t*(b - a)
  end
  
  def self.fade(t)
    t*t*t*(t*(t*6.0 - 15.0) + 10.0)
  end
  
  def self.sample(t)
    floor = t.floor
    i = Integer(floor)
    t -= floor
    
    lerp(fade(t), VALUES[i%NUM_VALUES]*t, VALUES[(i + 1)%NUM_VALUES]*(t - 1.0)) + 0.5
  end
end
