module LoadScreen
	tex = AS::RectTexture.open('gfx/openingScreen.png')
	LoadScreenNode = AS::Scene::ColorNode.new(AS::Color::White.pack) do
		AS::Scene::BlendNode.new(nil, GL::SRC_ALPHA, GL::ONE_MINUS_SRC_ALPHA) do
			AS::Scene::CopyRectNode.new(tex, 0, 0, tex.w, tex.h, -160, -120, 320, 240)
		end
	end
	
	def self.draw_with_alpha(alpha)
		LoadScreenNode.packed_color.color = AS::Color::RGB.new(1.0, 1.0, 1.0, alpha)
		
		LoadScreenNode.render
	end
	
	def self.show
		AS.clear_screen
		draw_with_alpha(1.0)
		AS.swap_buffers
	end
end